org.apache.commons.io.input

## Class TaggedReader

- java.lang.Object
- - java.io.Reader
  - - java.io.FilterReader
    - - org.apache.commons.io.input.ProxyReader
      - - org.apache.commons.io.input.TaggedReader

- All Implemented Interfaces:
    Closeable, AutoCloseable, Readable

      public class TaggedReader
      extends ProxyReader

  A reader decorator that tags potential exceptions so that the reader that caused the exception can easily be identified. This is done by using the `TaggedIOException` class to wrap all thrown `IOException`s. See below for an example of using this class.

       TaggedReader reader = new TaggedReader(...);
       try {
           // Processing that may throw an IOException either from this reader
           // or from some other IO activity like temporary files, etc.
           processReader(reader);
       } catch (IOException e) {
           if (reader.isCauseOf(e)) {
               // The exception was caused by this reader.
               // Use e.getCause() to get the original exception.
           } else {
               // The exception was caused by something else.
           }
       }

  Alternatively, the `throwIfCauseOf(Throwable)` method can be used to let higher levels of code handle the exception caused by this reader while other processing errors are being taken care of at this lower level.

       TaggedReader reader = new TaggedReader(...);
       try {
           processReader(reader);
       } catch (IOException e) {
           reader.throwIfCauseOf(e);
           // ... or process the exception that was caused by something else
       }

  Since:
    2.7
  See Also:
    `TaggedIOException`

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterReader

      `in`

    - ### Fields inherited from class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TaggedReader(Reader proxy)` Creates a tagging decorator for the given reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `handleIOException(IOException e)` Tags any IOExceptions thrown, wrapping and re-throwing.
    `boolean` | `isCauseOf(Throwable exception)` Tests if the given exception was caused by this reader.
    `void` | `throwIfCauseOf(Throwable throwable)` Re-throws the original exception thrown by this reader.

    - ### Methods inherited from class org.apache.commons.io.input.ProxyReader

      `afterRead, beforeRead, close, mark, markSupported, read, read, read, read, ready, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TaggedReader

          public TaggedReader(Reader proxy)

      Creates a tagging decorator for the given reader.
      Parameters:
        `proxy` - reader to be decorated

  - ### Method Detail

    - #### isCauseOf

          public boolean isCauseOf(Throwable exception)

      Tests if the given exception was caused by this reader.
      Parameters:
        `exception` - an exception
      Returns:
        `true` if the exception was thrown by this reader, `false` otherwise

    - #### throwIfCauseOf

          public void throwIfCauseOf(Throwable throwable)
                              throws IOException

      Re-throws the original exception thrown by this reader. This method first checks whether the given exception is a `TaggedIOException` wrapper created by this decorator, and then unwraps and throws the original wrapped exception. Returns normally if the exception was not thrown by this reader.
      Parameters:
        `throwable` - an exception
      Throws:
        `IOException` - original exception, if any, thrown by this reader

    - #### handleIOException

          protected void handleIOException(IOException e)
                                    throws IOException

      Tags any IOExceptions thrown, wrapping and re-throwing.
      Overrides:
        `handleIOException` in class `ProxyReader`
      Parameters:
        `e` - The IOException thrown
      Throws:
        `IOException` - if an I/O error occurs.

Copyright © 2002–2021 The Apache Software Foundation. All rights reserved.